function w=timeplot(data,xlims,ylims,titles,xgridstep)
  //Check the input data
  if type(data)==1
   [tmp,nofplots]=size(data); nofplots=nofplots-1;
  elseif type(data)==15
   nofplots=size(data);
  else
   error("Wrong format of data");
  end
  srect=[0,0,1,1];
  drect=srect;
  xsetech(srect,drect);
  //Calculate the x description height
  xdh=xstringl(0,0,["1";"2"]); xdh=xdh(4);


  //Now calculate the plot title height
  th=xstringl(0,0,["Xy"]); th=th(4)*1.2;


  //Now calculate the plot's height
  plh=(1-xdh)/nofplots-th;
  if plh<2*th then; plh=2*th; end //plots will not fit on the screen - we can't cure it


  ybot=xdh;
  //Now we calculate the Y-positions of particular plots and titles
  yplots=[...
    ((1:nofplots)-1)*(th+plh);...
    (1:nofplots)*(th+plh)-th]+xdh;
  ytitles=((1:nofplots)-1)*(th+plh)+plh+xdh;
  ylevs=list();
  ystrs=list();
  //Now we create the Y-levels for each plot
  for i=1:nofplots
    noflev=plh/th/1.2;
    ylevs(i)=tpl_grid(ylims(i,:),noflev);
    ystrs(i)=tpl_ylabels(ylevs(i));
  end


  //Now we allocate the X-space for Y-levels labels
  xmax=0;
  for i=1:nofplots
    for j=1:max(size(ylevs(i)))
      tmp=xstringl(0,0,ystrs(i));
      if tmp(3)>xmax then; xmax=tmp(3); end
    end
  end


  //Calculate the x grid lines basing on the xgridstep
  xlevs=floor(xlims(1)/xgridstep)*xgridstep;
  xlevs=(xlevs+xgridstep):xgridstep:xlims(2);


  //and map it into the screen coordinates
  sxlevs=xmax+(xlevs-xlims(1))/(xlims(2)-xlims(1))*(1-xmax);


  //Next array used to plot the grid
  gxlevs=[sxlevs;sxlevs];
  if type(data)==1
    //xdata are common for all plots
    x=data(:,1);
    x=xmax+(x-xlims(1))/(xlims(2)-xlims(1))*(1-xmax)
  end


  //Now draw the xlabels, preventing the overwriting of the previous ones
  x_end=-1
  for i=1:max(size(xlevs))
    tmp1=tpl_xlabel(xlevs(i));
    if sxlevs(i)>x_end
       tmp2=xstringl(sxlevs(i),0,tmp1);
       if sxlevs(i)+tmp2(3)<=1
          xstring(sxlevs(i),0,tmp1);
          x_end=sxlevs(i)+tmp2(3);
       end
    end
  end


  //Draw all subplots
  for i=1:nofplots
    //First the plot's title
    tmp1='min='+string(ylims(i,1));
    if titles(i,2)~=emptystr()
       tmp1=tmp1+' ['+titles(i,2)+']'
    end
    xstring(xmax,ytitles(i)+0.1*th,tmp1)
    tmp1='max='+string(ylims(i,2));
    if titles(i,2)~=emptystr()
       tmp1=tmp1+' ['+titles(i,2)+']'
    end
    tmp2=xstringl(0,0,tmp1);
    xstring(1-tmp2(3),ytitles(i)+0.1*th,tmp1)
    tmp2=xstringl(0,0,titles(i,1));
    xstring(0.5*(xmax+1-tmp2(3)),ytitles(i)+0.1*th,titles(i,1));
    //set the clipping
    xclip([xmax,yplots(2,i),1-xmax,yplots(2,i)-yplots(1,i)]);
    //Lets plot the curve.
    //The code below is the "quick and dirty implementation", because
    //it treats each data format separately. A lot of cut & pasted code... :-(
    if type(data)==1
       y=data(:,i+1);
       y=(y-ylims(i,1))/(ylims(i,2)-ylims(i,1))*(yplots(2,i)-yplots(1,i))+yplots(1,i);
       xpoly(x,y,'lines')
    elseif type(data(i))==1 //data is the list, but it may be the list of lists
       x=data(i)(:,1);
       y=data(i)(:,2);
       x=xmax+(x-xlims(1))/(xlims(2)-xlims(1))*(1-xmax)
       y=(y-ylims(i,1))/(ylims(i,2)-ylims(i,1))*(yplots(2,i)-yplots(1,i))+yplots(1,i);
       xpoly(x,y,'lines')
    else
       for j=1:size(data(i))
          x=data(i)(j)(:,1);
          y=data(i)(j)(:,2);
          x=xmax+(x-xlims(1))/(xlims(2)-xlims(1))*(1-xmax)
          y=(y-ylims(i,1))/(ylims(i,2)-ylims(i,1))*(yplots(2,i)-yplots(1,i))+yplots(1,i);
          xpoly(x,y,'lines');
       end
    end


    //Plot the vertical grid
    tmp=[yplots(1,i)*ones(sxlevs);yplots(2,i)*ones(sxlevs)];
    xsegs(gxlevs,tmp,2)


    //Plot the horizontal grid
    tmp=(ylevs(i)-ylims(i,1))/(ylims(i,2)-ylims(i,1))*(yplots(2,i)-yplots(1,i))+yplots(1,i);
    tmp2=[xmax*ones(tmp);ones(tmp)];
    tmp=[tmp;tmp];
    xsegs(tmp2,tmp,2);


    //End finally the ylabels
    xclip();
    xrect(xmax,yplots(2,i),1-xmax,yplots(2,i)-yplots(1,i));
    for j=1:max(size(ylevs(i)))
      tmp2=xstringl(0,0,ystrs(i)(j));
      xstring(xmax-tmp2(3),tmp(1,j)-0.5*tmp2(4),ystrs(i)(j))
    end
  end
  //Finally prepare the output array, which may be used for mapping
  //of xclick coordinates into the plot numbers and data coordinates
  w=list([xmax , 1 , xlims],...
    [yplots' ylims]);
return


